{{- $dot := . }}
{{ range $name, $task := .Values.cronjobs }}
{{ if $task.enabled }}
---
apiVersion: batch/v1beta1
kind: CronJob
metadata:
  name: "{{ include "app.fullname" $dot }}-cron-{{ $name }}"
  labels:
    {{- include "app.labels" $dot | nindent 4 }}
    app.kubernetes.io/component: "cron-{{ $name }}"
spec:
  schedule: {{ $task.schedule | quote }}
  concurrencyPolicy: "Forbid"
  successfulJobsHistoryLimit: 1
  startingDeadlineSeconds: 400
  jobTemplate:
    spec:
      template:
        metadata:
          annotations:
            checksum/config: {{ include (print $.Template.BasePath "/app-cm.yaml") $dot | sha256sum }}
            checksum/secret: {{ include (print $.Template.BasePath "/app-secret.yaml") $dot | sha256sum }}
          {{- with $.Values.podAnnotations }}
            {{- toYaml . | nindent 12 }}
          {{- end }}
          labels:
            {{- include "app.labels" $dot | nindent 12 }}
            app.kubernetes.io/component: "cron-{{ $name }}"
        spec:
          securityContext:
            {{- toYaml $.Values.podSecurityContext | nindent 12 }}
          volumes:
            - name: tz-config
              hostPath:
                path: /usr/share/zoneinfo/Europe/Moscow # TODO: поменять на UTC
                type: File
            - name: entrypoint
              configMap:
                name: "{{ include "app.fullname" $ }}"
                items:
                  - key: entrypoint
                    path: entrypoint.sh
                    mode: 0777
            {{- if $.Values.app.extraVolumes }}
            {{- toYaml $.Values.app.extraVolumes | nindent 12 }}
            {{- end }}
          restartPolicy: OnFailure
          {{- with $.Values.imagePullSecrets }}
          imagePullSecrets:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          containers:
            - name: {{ $task.container }}
              image: "{{ $.Values.app.image.repository }}:{{ $.Values.app.image.tag }}"
              imagePullPolicy: {{ $.Values.app.image.pullPolicy }}
              securityContext:
                {{- toYaml $.Values.securityContext | nindent 16 }}
              command:
                - "/usr/local/bin/entrypoint.sh"
              args:
                {{- toYaml $task.command | nindent 16 }}
              resources:
                {{- toYaml (default $.Values.app.resources $task.resources) | nindent 16 }}
              volumeMounts:
                - name: tz-config
                  mountPath: /etc/localtime
                - name: entrypoint
                  mountPath: /usr/local/bin/entrypoint.sh
                  subPath: entrypoint.sh
                {{- if $.Values.app.extraVolumeMounts }}
                {{- toYaml $.Values.app.extraVolumeMounts | nindent 16 }}
                {{- end }}
              env:
              {{- with $.Values.app.env }}
                {{- include "env" (list $ . false) | nindent 16 }}
              {{- end }}
              {{- with $task.env }}
                {{- include "env" (list $ . false) | nindent 16 }}
              {{- end }}
          {{- with $.Values.nodeSelector }}
          nodeSelector:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with $.Values.affinity }}
          affinity:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with $.Values.tolerations }}
          tolerations:
            {{- toYaml . | nindent 12 }}
          {{- end }}
{{ end }}
{{ end }}
